package Comunicacao;

import camadaDados.Conexao;
import classesBasicas.Abastece;
import java.io.*;
import java.net.*;
import java.text.DateFormat;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.LinkedBlockingQueue;
import negocios.ControleVeiculo;
import negocios.UtilidadesFuncionario;




public class Server implements Runnable{

	private ServerSocket welcomeSocket;
	private int port = 9000;
	private ExecutorService executor;
	public LinkedBlockingQueue<String> usuariosLogados; // guarda usu?rios online
        private ControleVeiculo controleVeiculo;
        private UtilidadesFuncionario controlefuncionario;

	public Server() throws Exception{
		try {
                        controlefuncionario = new UtilidadesFuncionario(new Conexao());
                        controleVeiculo = new ControleVeiculo(new Conexao());
                    
			this.welcomeSocket = new ServerSocket(port);
                        
			this.usuariosLogados = new LinkedBlockingQueue<String>();
			executor = Executors.newCachedThreadPool();
			executor.execute(this);
                      

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void run() {
		try {

			while (true) {

                                System.out.println("rodando");
				Socket socket = welcomeSocket.accept();
				System.out.println("chegou!!");
				executor.execute(new FuncionarioHandler(socket));

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public class FuncionarioHandler implements Runnable {

		private Socket cliente;
		private String login;
		private String senha;
		private boolean logado;
		private ObjectInputStream entrada;
		private ObjectOutputStream saida;

		public FuncionarioHandler(Socket cliente) throws IOException{

			this.cliente = cliente;
			this.login = "default";
			this.logado = true;
			this.entrada = new ObjectInputStream (this.cliente.getInputStream());
			this.saida = new ObjectOutputStream (this.cliente.getOutputStream());
			this.saida.flush();

		}


		public void run(){

			try{

				while(this.logado){

					String mensagem = (String) this.entrada.readUnshared();
 
					StringTokenizer tokenizedLine = new StringTokenizer(mensagem, "_");
                                                            
					String comando = tokenizedLine.nextToken();
					System.out.println(mensagem);

					//					String comando = (String) this.entrada.readUnshared();
					//					StringTokenizer tokenizedLine = new StringTokenizer(comando);

					//if(comando.getCommand().equals("CONNECT")){
					if(comando.equals("CONNECT")){

						this.saida.writeUnshared(new String("VALIDATE"));
						System.out.println("Novo cliente conectado.");

					}

					//if(comando.getCommand().equals("LOGIN")){
					if(comando.equals("LOGIN")){

						this.login = tokenizedLine.nextToken();
						this.senha = tokenizedLine.nextToken();
						//funcion?rio j? est? logado
						if(usuariosLogados.contains(this.login)){

							//this.saida.writeUnshared(new Message("Insucesso", "J? est? logado!"));
							this.saida.writeUnshared(new String("INVALIDATE"));
							System.out.println(this.login + " j? est? logado.");

						}else{
							//verifica login/senha
                                                        boolean sucesso = false;
                                                        try{
                                                            sucesso = controlefuncionario.logar(login, senha);
                                                        }catch(Exception e){
                                                            sucesso = false;
                                                        }
                                                        if(sucesso){
                                                            usuariosLogados.add(this.login);
                                                            this.saida.writeUnshared(new String("VALIDATE"));
                                                            System.out.println(this.login + " est? logado.");
                                                        }else{
                                                            this.saida.writeUnshared(new String("INVALIDATE"));
                                                            System.out.println(this.login + " não foi possivel logar.");
                                                        }
						}

					}

					//if(comando.getCommand().equals("NEWABST")){
					if(comando.equals("NEWABST")){

						String latitude = tokenizedLine.nextToken();
                                                System.out.println(latitude);
						String longitude = tokenizedLine.nextToken();
                                                System.out.println(longitude);
                                                String CEP = tokenizedLine.nextToken();
                                                System.out.println(CEP);
						String logradouro = tokenizedLine.nextToken();
                                                System.out.println(logradouro);
						String bairro = tokenizedLine.nextToken();
                                                System.out.println(bairro);
						String estado = tokenizedLine.nextToken();
                                                System.out.println(estado);
						String cidade = tokenizedLine.nextToken();
                                                System.out.println(cidade);
						String numero = tokenizedLine.nextToken();
                                                System.out.println(numero);
						String nomeEmpresa = tokenizedLine.nextToken();
                                                System.out.println(nomeEmpresa);
						String tipoComb = tokenizedLine.nextToken();
                                                System.out.println(tipoComb);
						String qtdComb = tokenizedLine.nextToken();
                                                System.out.println(qtdComb);
						String precoComb = tokenizedLine.nextToken();
                                                System.out.println(precoComb);
						String quilometragem = tokenizedLine.nextToken();
                                                System.out.println(quilometragem);
						String placa = tokenizedLine.nextToken();
                                                System.out.println(placa);
                                                Date now = new Date();
                                                DateFormat df = DateFormat.getDateInstance();
                                                String dataAbastecimento = df.format(now);
                                                System.out.println(dataAbastecimento);
                                                try{
                                                     controleVeiculo.realizarAbatecimento(Integer.parseInt(CEP), Integer.parseInt(numero), nomeEmpresa, 0, logradouro, bairro, cidade, estado, "Brasil", latitude, longitude, placa, Integer.parseInt(quilometragem), dataAbastecimento, tipoComb, Integer.parseInt(qtdComb), Integer.parseInt(precoComb));
                                                     this.saida.writeUnshared(new String("VALIDATE"));
                                                     System.out.println("valido");
                                                }catch(Exception e){
                                                    this.saida.writeUnshared(new String("INVALIDATE"));
                                                    System.out.println("invalido");
                                                    System.out.println(e.getMessage());
                                                }
					}

					//if(comando.getCommand().equals("INDABST")){
					if(comando.equals("INDABST")){
                                                
						String latitude = tokenizedLine.nextToken();
						String longitude = tokenizedLine.nextToken();
                                                try{
                                                    //retornar o posto
                                                    //enviar posto
                                                    String localAbastecimento = controleVeiculo.indicarLocalAbastecimento(latitude, longitude);
                                                    this.saida.writeUnshared(new String(localAbastecimento));
                                                    System.out.println("Abastecimento");
                                                }catch(Exception e){
                                                    this.saida.writeUnshared(new String("INVALIDATE"));
                                                    System.out.println(e.getMessage());
                                                }
						

					}

					//if(comando.getCommand().equals("DISCONNECT")){
					if(comando.equals("DISCONNECT")){

						usuariosLogados.remove(this.login);
						this.saida.writeUnshared(new String("VALIDATE"));
						System.out.println(this.login + " desconectado");
						this.logado = false;

					}

				}

				this.entrada.close();
				this.saida.close();
				this.cliente.close();

			}catch(IOException e){

				if(!this.login.equals("default")){
					usuariosLogados.remove(this.login);
					System.out.println("Conex?o com " + this.login + " encerrada!");
				}else{
					System.out.println("Conex?o encerrada!");
				}
				this.logado = false;
				//e.printStackTrace();
			} catch (ClassNotFoundException e) {
				e.printStackTrace();
				System.out.println("Separaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa");
				e.getCause();
			}
		}
	}

	public static void main(String argv[]) throws Exception {
		new Server();
	}
}
